#ifdef ultrix
#	define POSIX
#	define __POSIX
#endif

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>
#include <fcntl.h>
#include <errno.h>
#include <pwd.h>
#include <grp.h>
#include <utmp.h>
#include <time.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "version.h"

/* HM's must have / at the end !!! */

#if defined(__linux__)
#define HM "/home/"
#if defined(__i386__) || defined(__x86_64__)
#include "quota.h"  /* From quota-3.09, works only for new quota! */
#include "quotaio.h"
#include "dqblk_v2.h"
#include <mntent.h>
#elif defined(__sparc__)
#include <sys/quota.h>
#include <mntent.h>
#else
#error Unknown architecture!
#endif
#elif defined(__SVR4)
#define HM "/home/"
#include <sys/fs/ufs_quota.h>
#elif defined(__osf__)
#if defined(DU4)
#define HM "/home/"
#include <sys/security.h>
#include <prot.h>
#include <ufs/quota.h>
int quotactl(char *, int, int, char *);
#else
#define HM "/usr/users/"
#include <ufs/quota.h>
int quotactl(char *, int, int, char *);
#endif
#elif defined(ultrix)
#define HM "/usr/users/"
#include <sys/param.h>
#include <sys/quota.h>
int quota(int, int, int, caddr_t);
extern int setreuid(uid_t, uid_t);
extern int seteuid(uid_t);
extern int putenv(char *);
#endif

#define ALL 0			/* forbidden + srce + admin */
#define NOTALL 1		/* only forbidden */
#define ERROR 2			/* error condition */
#define OK 3			/* everything's fine */

#define OFF 0			/* drop privileges */
#define ON 1			/* get priviliges */

#define MAXLOGIN 16		/* max login size + 1 */
#define MAXGROUP 16		/* max group name + 1 */
#define MAXNAME 64		/* max username size + 1 */
#define MAXSTR 64		/* max input string for quota numbers + 1 */
#define MAXDIR 1024		/* max pathlen */
#define MAXCOMMAND 256		/* max string length for system() */
#define MAXQUOTA 262144		/* max quota in KB */
#define MAXMESS 200		/* max message length for shutdown */
#define MINGRACE 1		/* min grace period for shutdown */
#define MAXGRACE 60		/* max grace period for shutdown */

#define CONSOLE "/dev/console"	/* console device */

#define CONF_NOCONSOLE "no_console_check" /* Config: don't check for console */

#if defined (__linux__) || defined(__SVR4)
#define LOGFILE "/var/log/sysadmin.log" /* logfile */
#define ACLFILE "/etc/sysadmin/users"   /* acl file */
#define OPTFILE "/etc/sysadmin/config"  /* config */
#define GROUPFILE "/etc/group" /* group file */
#define GROUPTMPFILE "/tmp/group" /* tmp group file */
#if defined (__linux__)
#define MANFILE "/usr/share/sysadmin/sysadm.man" /* online manual */
#define PARSE_USERADD_DEFAULTS 1
#else /* __SVR4 */
#define MANFILE "/usr/local/share/sysadmin/sysadm.man" /* online manual */
#endif
#else
#define LOGFILE "/var/adm/adminlog" /* logfile */
#define ACLFILE "/etc/adminusers"   /* acl file */
#define OPTFILE "/etc/adminconfig"  /* config */
#define MANFILE "/etc/sysadm.man"   /* online manual */
#endif

#if defined(__linux__)
#define DEFAULTSHELL "/bin/bash"
#else
#define DEFAULTSHELL "/bin/csh"
#endif

/* function prototypes */

void logger(char *, ...);
void printpriv(char *);
void priv(int);
int lockpw(void);
void unlockpw(void);
void consexit(void);
int getch(void);
void clear(void);
void waitkey(void);
void enter(char *, int);
void getuser(char *);
void getgroup(char *);
int getname(void);
int getdir(void);
int getquota(int *, int *);
int testuser(int);
int testgroup(void);
int system_default_shell_check(void);
void adduser(void);
void rmuser(void);
void chpass(void);
void chquota(void);
void opgroup(void);
void shutdown(void);
void manual(void);
void banner(void);
void console_check(char *);
